﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Goozon
{
    public partial class MainWindow : Form
    {
        #region "クラス変数"
        //検索結果の識別番号
        public int count = 0;
        //新規作成Windowのカウンター
        private int childFormNumber = 0;
        #endregion
        #region "コンストラクター"
        ///<summary >
        /// コンストラクター
        ///</summary>
        public MainWindow()
        {
            InitializeComponent();
        }
        #endregion
        #region "ユーザーが起こすイベント関連"
        ///<summary >
        ///検索ボタンのハンドラー(検索の実行)        
        ///</summary>
        private void button1_Click(object sender, EventArgs e)
        {
            if (this.textBox1.Text != null && this.textBox1.Text != "")
            {
                FrmGoozon seekresult = new FrmGoozon(this.textBox1.Text, this.count);
                seekresult.MdiParent = this;
                seekresult.Visible   = true;
                this.listBox1.Items.Add(this.textBox1.Text);
                this.count += 1;//識別番号のインクリメント
            }else{
                MessageBox.Show("検索文字を入力してください、\n現在何も入力されていません。" ,"検索条件エラー");
            }
        }
        ///<summary >
        ///メニューのハンドラー(検索バーの表示)
        ///</summary>
        private void statusBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.statusBarToolStripMenuItem.Checked == true)
            {
                this.panel1.Visible = true;
            }
            else
            {
                this.panel1.Visible = false;

            }
            this.Refresh();
        }
        ///<summary >
        ///メニューのハンドラー(履歴の表示)
        ///</summary>
        private void ToolStripMenuItemHistory_Click(object sender, EventArgs e)
        {
            {
                if (this.ToolStripMenuItemHistory.Checked == true)
                {
                    this.panel2.Visible = true;
                }
                else
                {
                    this.panel2.Visible = false;
                }
                this.Refresh();
            }
        }
        ///<summary >
        ///メニューのハンドラー(アプリケーションを終了する)
        ///</summary>        
        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        ///<summary >
        ///メニューのハンドラー(すべてのウインドウを閉じる)
        ///</summary>        
        private void closeAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            foreach(FrmGoozon MDIS in this.MdiChildren ){
                MDIS.Close();
            }
        }
        ///<summary >
        ///メニューのハンドラー(横に表示)
        ///</summary>
        private void tileVerticalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileVertical);
        }
        ///<summary >
        ///メニューのハンドラー(縦に表示)
        ///</summary>
        private void tileHorizontalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileHorizontal);
        }
        ///<summary >
        ///メニューのハンドラー(重ねて表示)
        ///</summary>  
        private void cascadeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.Cascade);
        }
        ///<summary >
        ///メニューのハンドラー(新しいウインドウを作成)
        ///</summary>
        private void newWindowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MainWindow childForm = new MainWindow();
            // 表示する前に、この MDI フォームの子に設定します。
            childForm.MdiParent = this;
            childForm.Text = "ウィンドウ " + childFormNumber++;
            childForm.Show();
        }
        ///<summary >
        /// 履歴ボックスのハンドラー(主にマウスでクリックした時動作)
        ///</summary>
        private void listBox1_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (this.listBox1.SelectedIndex >= 0)
            {
                bool nofineded;
                nofineded = true;
                //履歴に対応する子供の検索
                foreach (FrmGoozon mdiChild in this.MdiChildren)
                {
                    if (mdiChild.myIdentity == this.listBox1.SelectedIndex)
                    {
                        mdiChild.Select();
                        nofineded = false;
                    }

                }
                //子供になかったら新規作成
                if (nofineded)
                {
                    FrmGoozon seekresult = new FrmGoozon(this.listBox1.SelectedItem.ToString () , this.listBox1.SelectedIndex);
                    seekresult.MdiParent = this;
                    seekresult.Visible = true;
                }
            }
        }
        ///<summary >
        ///検索文字ボックスのハンドラー(Enterを押した時動作)
        ///</summary>
        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter) {
                this.button1_Click(sender, e);
            }
        }
        #endregion

    }
}